#!/usr/bin/perl

require "config.pl";

if ($ENV{'REQUEST_METHOD'} eq "GET") {
 $buffer = $ENV{'QUERY_STRING'};
} 
elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
 read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
 ($name, $value) = split(/=/, $pair);
 $value =~ tr/+/ /;
 $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $value =~ s/<([^>]|\n)*>//g;
 $value =~ s/<!--(.|\n)*-->//g;
 #    :
 $value =~ s/^\s+//;
 $value =~ s/\s+$//;
 $FORM{$name} = $value;
}

print "Content-type: text/html\n\n<html><head><LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\"style.css\"></head><body>";
$action = $FORM{'action'};

if ($action eq 'help') { &help; }
elsif ($action eq 'whohere') { &whohere; }
elsif ($action eq 'meetform') { &uplink; &meetform; }
elsif ($action eq 'meeting') { &meeting; }
elsif ($action eq 'addmeet') { &addmeet; }
elsif ($action eq 'addform') { &addform; }
elsif ($action eq 'addnick') { &addnick; }
elsif ($action eq 'chform') { &chform; }
elsif ($action eq 'chpass') { &chpass; }
else {  &title; &menu; }
print "</body></html>";
exit;

sub title {
 print "<p align=center><img src=\"$imagesfolder/title.jpg\" width=200 height=100 align=center alt=\"  \"></p>";
}

sub uplink {
 &title;
 print "<p align=right class=menu><a href=\"$right\"></a>";
}

sub menu {
 print <<MENU1;
<p align=right class=menu><a href="$right?action=help">&nbsp;&nbsp;</a>
<p align=left class=menu><a href="$right?action=whohere">&nbsp;&nbsp;?</a>
<p align=right class=menu><a href="$right?action=meetform">&nbsp;</a>
<p align=left class=menu><a href="$right?action=addform">&nbsp;!</a>
<p align=right class=menu><a href="$right?action=chform">&nbsp;</a>
<p align=right class=menu>&nbsp;</p>
<p align=left class=menu><a href="http://www.mail.ru" target=_top></a>
<p align=right class=menu><a href="http://www.ya.ru" target=_top></a>
<p align=left class=menu><a href="http://pers.narod.ru" target=_top>(</a>
<p align=right class=menu><a href="http://pers.narod.ru" target=_top> right.pl)</a>
MENU1
}

sub whohere {
 open (DATA, "$nickdata");
 @data = <DATA>;
 close (DATA);
 &uplink;
 print "<p align=left class=menu> :";
 for ($i=0; $i<$#data; $i++) {
  print "$data[$i]";
 }
}

sub help {
 open (DATA, "$helpdata");
 @data = <DATA>;
 close (DATA); 
 print "<html><head><LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\"style.css\"></head><body>";
 &uplink;
 if (@data) {
  foreach $line(@data) {
   print "$line";
  }
 }
 else {
  print "<p>,   $helpdata    </p>";
 }
 print "</body></html>";
}

sub passed { #1,  , .  , 
 $day1=@_[0];  $mon1=@_[1];  $hour1=@_[2];  $min1=@_[3];
 ($sec,$min2,$hour2,$day2,$mon2,$year,$wday) = localtime(time);
 if ($mon2==0) { $mon2=12; }
 if ($mon1==0) { $mon1=12; }
 if ($mon2>$mon1) { return 1; }
 elsif ($mon2==$mon1) {
  if ($day2>$day1) { return 1; }
  elsif ($day2==$day1) {
   if ($hour2>$hour1) { return 1; }
   elsif ($hour2==$hour1) {
    if ($min2>=$min1) { return 1; }
   }
  }
 }
 return 0;
}

sub meeting { #   $name
 @md=('','','','','','','','','','','','');
 $name = lcr($FORM{'name'});
 &uplink;
 open (DATA, "$meetdata");
 @data = <DATA>;
 close (DATA);
 if (@data) {
  $meets=0;
  foreach $line(@data) {  
   chomp $line;
   ($name1,$who1,$date,$time,$mess)=split (/\t/,$line);
   if (lcr($name1) eq $name) {
    $meets++;
    ($day1,$mon1)=split (/:/,$date);
    ($hour1, $min1)=split (/:/,$time);
    print "<p>$meets) ";
    if ($who1 ne "") { print ": $who1, "; }
    print "$day1 $md[$mon1]  $time";
    if ($mess ne "") { print "<br>: $mess"; }
    if (&passed($day1,$mon1,$hour1,$min1)==1) {
     print "<small><font color=red>( )</font></small>";
    }
    print "</p>";
   }
  }
  if ($meets==0) {
   print "<p>  $name     </p>";
  }
  else {
   print "<p>  $name  $meets ";
   if ($meets%10==1) { print ""; }
   elsif (($meets%10>1) and ($meets%10<5)) { print ""; }
   print "</p>";
  }
 }
 else {
  print "<p>,  $meetdata      </p>";
  exit;
 }
 &meetform;
}

sub addmeet { #   $name  $who
 &uplink;
 @mdr=('','','','','','','','','','','','');
 $name = lcr($FORM{'name'});
 $who= lcr($FORM{'who'});
 $date= $FORM{'date'};
 $time= $FORM{'time'};
 $mess= $FORM{'mess'};
 if ($name eq "") {
  print "<p>,    ,   </p>";
  exit;
 }
 if ($who eq "") {
  print "<p>,     </p>";
  exit;
 }
 if ($name eq $who) {
  print "<p>,      :-)</p>";
  exit;
 }
 ($day1,$mon1)=split (/:/,$date);
 ($hour1, $min1)=split (/:/,$time);
 if (&passed ($day1,$mon1,$hour1, $min1)==1) {
  print "<p>,       :-)</p>";
  exit;
 }
 open (DATA, "$meetdata");
 @data = <DATA>;
 close (DATA);
 $i=0; 
 foreach $line(@data) {
  chomp $line;
  ($name1,$who1,$date1,$time1,$mess1)=split (/\t/,$line);
  ($day1,$mon1)=split (/:/,$date1);
  ($hour1,$min1)=split (/:/,$time1);
  if (&passed($day1,$mon1,$hour1, $min1)==0) {
   $newdata[$i++]="$name1\t$who1\t$date1\t$time1\t$mess1\n";
  }
 }
 $newdata[$i]="$name\t$who\t$date\t$time\t$mess";
 open (DATA, ">$meetdata");
 flock(DATA,2);
 print DATA @newdata;
 flock(DATA,8);
 close (DATA);
 ($day,$mon)=split (/:/,$date); 
 if ($day<10) { $day="$day\n"; }
 if ($mon<10) { $mon="$mon\n"; }
 print "<p>   $name  ($day $mdr[$mon]  $time)</p>";
 &meetform;
}

sub meetform {
 # ""  
 if ($FORM{'name'}) { $whostart=lcr($FORM{'name'}); }
 else { $whostart=""; }
 #   IP
 open (DATA, "$regdata");
 @data = <DATA>;
 close (DATA);
 $now=time;
 $thisIP=$ENV{'REMOTE_ADDR'};
 $start="";
 foreach $line(@data) {
  chomp $line;
  ($ip,$oldname,$pass,$oldtime,$col,$eff)=split (/\t/,$line);
  if ($ip eq $thisIP) {
   $start=$oldname;
  }
 }
 print "<table border=0 width=100%><tr><td>";
 print "<p> :</p>";
 print "<form name=F1 method=get>";
 print "<input type=hidden name=action value=\"meeting\">";
 print "<input type=text name=name size=20 maxlen=60 value=\"$start\">";
 print "<br><input type=submit class=button name=\"OK\" value=\"OK\"></form></td></tr><tr><td><p> :</p><form name=F2 method=get>";
 print "<input type=hidden name=action value=\"addmeet\">";
 print "<p><input type=text name=name size=20 maxlen=60 value=\"$whostart\"></p>";
 print "<p> : <input type=text name=who size=20 maxlen=60 value=\"$start\"></p>";
 print "<p>: ";
 &printdate;
 print "</p><p>: ";
 &printtime;
 print "</p><p>:<br>";
 print "<input type=text name=mess size=20 maxlen=254 value=\"\">";
 print "<br><input type=submit class=button name=\"OK\" value=\"OK\"></form>";
 $str2=&ctime;
 print "<small> : $str2</small></td></tr></table>";
}

sub kdays {
 $m=@_[0];
 $y=@_[1];
 if ($y<1900) { $y+=1900; }
 @md=(31,28,31,30,31,30,31,31,30,31,30,31);
 if (($y%4==0) && ($y%100!=0) || ($y%400==0)) { $md[1]=29; }
 return ($md[$m]);
}

sub printdate {
 @mdr=('','','','','','','','','','','','');
 ($sec,$min,$hour,$day1,$mon1,$year1,$wday1) = localtime(time);
 $day2= &kdays ($mon1,$year1);
 print"<select name=date size=1>";
 print"<option selected value=\"$day1:$mon1\">$day1 $mdr[$mon1]</option>";
 for ($i=$day1+1; $i<=$day2; $i++) {
  print"<option value=\"$i:$mon1\">$i $mdr[$mon1]</option>";
 }
 if ($mon1<11) { $mon1++; }
 else { $mon1=0; $year1++; }
 $day2= &kdays ($mon1,$year1);
 if ($day1>$day2) { $day1=$day2; }
 for ($i=1; $i<$day1; $i++) {
  print"<option value=\"$i:$mon1\">$i $mdr[$mon1]</option>";
 }
 print"</select>";
}

sub printtime {
 print"<select name=time size=1>";
 for ($h=0; $h<24; $h++) {
  for ($m=0; $m<46; $m+=15) {
   $h1=$h;
   if ($h<10) { $h1="0$h"; }
   $m1=$m;
   if ($m<10) { $m1="0$m"; }
   print "<option ";
   if (($h==12) && ($m==0)) { print "selected "; }
   print "value=\"$h1:$m1\">$h1:$m1</option>";
  }
 }
 print"</select>";
}

sub getname { #   IP
 open (DATA, "$regdata");
 @data = <DATA>;
 close (DATA);
 $now=time;
 $thisIP=$ENV{'REMOTE_ADDR'};
 $str="\tblack\t0";
 foreach $line(@data) {
  chomp $line;
  ($ip,$oldname,$pass,$oldtime,$col,$eff)=split (/\t/,$line);
  if ($ip eq $thisIP) {
   $str="$oldname\t$col\t$eff";
  }
 }
 return $str;
}

sub geteffect {
 $bold = $FORM{'bold'};
 $ital = $FORM{'ital'};
 $effect=0;
 if ($bold eq 'yes') { $effect|=1; }
 if ($ital eq 'yes') { $effect|=2; }
 return $effect;
}

sub checkname {
 $name=@_[0];
 if ($name eq "") {
  print "<p>,       </p>";
  exit;
 }
}

sub checkpass {
 $p1=@_[0];
 $p2=@_[1];
 if (($p1 eq "") or ($p2 eq "")) {
  print "<p>,      </p>";
  exit;
 }
 elsif ($p1 ne $p2) {
  print "<p>,    </p>";
  exit;
 }
}

sub gettime {
 $now=time;
 return $now+$days*86400;
}

sub getpass {
 $name=@_[0];
 open (DATA, "$regdata");
 @data = <DATA>;
 close (DATA);
 foreach $line(@data) {
  chomp $line;
  ($ip,$oldname,$pass,$oldtime,$col,$eff)=split (/\t/,$line);
  if (lcr($name) eq lcr($oldname)) {
   return "$pass";
  }
 }
 return "";
}

sub chpass {
 &uplink;
 $ip = $ENV{'REMOTE_ADDR'};
 $name = lcr($FORM{'name'});
 $oldpass1 = $FORM{'oldpass'};
 $pass1 = $FORM{'password'};
 $pass2 = $FORM{'password2'};
 $time = &gettime;
 $color = $FORM{'color'};
 $effect=&geteffect;
 &checkname ($name);
 $oldpass2=&getpass ($name);
 if ($oldpass2 eq "") {
  print "<p>,  $name      .     \" \"</p>";
  exit;
 }
 &checkpass ($oldpass1, $oldpass2); 
 &checkpass ($pass1, $pass2); 
 open (DATA, "$regdata");
 @data = <DATA>;
 close (DATA);
 $i=0; 
 $now=time;
 foreach $line(@data) {
  chomp $line;
  ($ip2,$name2,$pass2,$time2,$color2,$effect2)=split (/\t/,$line);
  if ($name eq lcr($name2)) {
   $newdata[$i++]="$ip\t$name\t$pass1\t$time\t$color\t$effect\n";
  }
  elsif ($time2>$now) {
   $newdata[$i++]="$line\n";
  }
 }
 open (DATA, ">$regdata");
 flock(DATA,2);
 print DATA @newdata;
 flock(DATA,8);
 close (DATA);
 print "<p>  $name  </p>";
 &menu; 
}

sub addnick {
 &uplink;
 $ip = $ENV{'REMOTE_ADDR'};
 $name = lcr($FORM{'name'});
 $pass1 = $FORM{'password'};
 $pass2 = $FORM{'password2'};
 $time = &gettime;
 $color = $FORM{'color'};
 $effect=&geteffect;
 &checkname ($name);
 &checkpass ($pass1, $pass2);
 open (DATA, "$regdata");
 @data = <DATA>;
 close (DATA);
 $i=0; 
 foreach $line(@data) {
  chomp $line;
  ($ip2,$name2,$pass2,$time2,$color2,$effect2)=split (/\t/,$line);
  if ($name eq lcr($name2)) {
   print "<p>,  $name  .   \" \"    </p>";
   exit;
  }
  elsif ($time2>$now) {
   $newdata[$i++]="$line\n";
  }
 }
 $newdata[$i]="$ip\t$name\t$pass1\t$time\t$color\t$effect\n";
 open (DATA, ">$regdata");
 flock(DATA,2);
 print DATA @newdata;
 flock(DATA,8);
 close (DATA);
 print "<p>  $name  </p>";
 &menu; 
}

sub chform {
 &uplink;
 $line=&getname;
 ($sname,$scolor,$seff)=split (/\t/,$line);
 print "<form name=f4 method=get>";
 print "<input type=hidden name=action value=\"chpass\">";
 print "<p> :<br>";
 print "<input type=text name=name size=20 maxlen=60 value=\"$sname\"></p>";
 print "<p> :<br>";
 print "<input type=password name=oldpass size=10 maxlen=10 value=\"\"></p>";
 print "<p> :<br>";
 print "<input type=password name=password size=10 maxlen=10 value=\"\"></p>";
 print "<p>   :<br>";
 print "<input type=password name=password2 size=10 maxlen=10 value=\"\"></p>";
 print "<p>: ";
 &printcolors ($scolor);
 print "</p><p>";
 print"<input type=checkbox name=bold value=\"yes\"";
 if ($seff%2==1) { print " checked"; }
 print"><b></b> <input type=checkbox name=ital value=\"yes\"";
 if ($seff>1) { print " checked"; }
 print"><i></i> ";
 print"<input type=submit name=ok class=button value=\"OK\"></form></p>";
}

sub addform {
 &uplink;
 $line=&getname;
 ($sname,$scolor,$seff)=split (/\t/,$line);
 print "<form name=f3 method=get>";
 print "<input type=hidden name=action value=\"addnick\">";
 print "<p>  :<br>";
 print "<input type=text name=name size=20 maxlen=60 value=\"$sname\"></p>";
 print "<p>  :<br>";
 print "<input type=password name=password size=10 maxlen=10 value=\"\"></p>";
 print "<p>  :<br>";
 print "<input type=password name=password2 size=10 maxlen=10 value=\"\"></p>";
 print "<p>: ";
 &printcolors ($scolor);
 print "</p><p>";
 print"<input type=checkbox name=bold value=\"yes\"";
 if ($seff%2==1) { print " checked"; }
 print"><b></b> <input type=checkbox name=ital value=\"yes\"";
 if ($seff>1) { print " checked"; }
 print"><i></i> ";
 print"<input type=submit name=ok class=button value=\"OK\"></form></p>";
}
